<?php
namespace Claromentis\Core\Ai;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"] ?: array()) + array("_a70b8baf1a135547a2710" . "0200b31ba5e" => base64_decode("c29" . "ydA" . "=="), "_e65d9ebe03c7" . "b68f03597f9bf" . "0f297d8" => base64_decode("RWFjaCBlbGVtZW50IG11c3QgYmUgYW4gaW5zdGFuY2Ugb2" . "Yg"), "_ea8229a1" . "21285ee64" . "9a72fd880" . "bac39b" => base64_decode("YXJyYXlfZml" . "sdGVy"), "_4298577e41" . "894bcce23f8" . "96cd365aea4" => base64_decode("Z" . "W" . "4" . "="), "_bd71c3b5" . "c201fc11d" . "b82ed14ce" . "424de5" => base64_decode("aW5" . "fYX" . "JyY" . "Xk="), "_2e384775c6854f15e613f8da88d" . "b608d" => base64_decode("Y2ZnX2FpX2VuYWJsZWRfbW9k" . "dWxlcw=="), "_24124167882dd54c5fd27" . "989982de707" => base64_decode("QUkgcGx1Z2luc" . "yBtdXN0IGltcG" . "xlbWVudCA="), "_34725a20914b07a28de7045e" . "f89ffe6e" => base64_decode("SW52YWx" . "pZCBwbH" . "VnaW4gd" . "HlwZQ=="), "_075c6c4172eaf58cfa8482" . "8a3582d19a" => base64_decode("YXJyYXlfdW5" . "pcXVl"));
use Claromentis\Core\Ai\Events\AiEvent;
use Claromentis\Core\Ai\Events\AiEventType;
use Claromentis\Core\Ai\Parts\PartInterface;
use Claromentis\Core\Ai\Util\Util;
use Claromentis\Core\Config\Config;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Webmozart\Assert\Assert;




class Ai implements AiAdapterInterface
{
    
    
    
    
    protected AiAdapterInterface $adapter;
    protected Config $config;
    
    
    
    
    protected EventDispatcherInterface $dispatcher;
    
    
    
    
    
    
    protected array $plugins;
    
    
    
    
    
    
    
    public function __construct(AiAdapterInterface $_fff71005fefc432e322a63468ff7fd0c, Config $config, EventDispatcherInterface $_b497ce6f2af10f67516aed0ecf34d8cf, array $_a99e51514fd0fcca58579cb5552a6035 = [])
    {
        Assert::allIsInstanceOf($_a99e51514fd0fcca58579cb5552a6035, AiPluginInterface::class, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_24124167882dd54" . "c5fd27989982de70" . "7"] . AiPluginInterface::class);
        $this->adapter = $_fff71005fefc432e322a63468ff7fd0c;
        $this->config = $config;
        $this->dispatcher = $_b497ce6f2af10f67516aed0ecf34d8cf;
        $this->plugins = $_a99e51514fd0fcca58579cb5552a6035;
    }
    public function generateText($_9961f986823b4be7f5c4cc8379c6b228, ?AiTextGenerationConfiguration $_91cc42f5289e2e63eeb6b3317a65abbd = null) : string
    {
        Util::assertTextGenerationParts($_9961f986823b4be7f5c4cc8379c6b228);
        $this->dispatchEvent(AiEventType::TEXT_PROMPT, $_9961f986823b4be7f5c4cc8379c6b228);
        return $this->adapter->generateText($_9961f986823b4be7f5c4cc8379c6b228, $_91cc42f5289e2e63eeb6b3317a65abbd);
    }
    public function generateChat(array $_9961f986823b4be7f5c4cc8379c6b228) : string
    {
        Assert::allIsInstanceOf($_9961f986823b4be7f5c4cc8379c6b228, PartInterface::class, $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_e65d9ebe" . "03c7b68f0" . "3597f9bf0" . "f297d8"] . PartInterface::class);
        $this->dispatchEvent(AiEventType::CHAT_PROMPT, $_9961f986823b4be7f5c4cc8379c6b228);
        return $this->adapter->generateChat($_9961f986823b4be7f5c4cc8379c6b228);
    }
    public function generateTextStream(callable $_5c51b0e4b7267b43adabf8015a8e1cf8, $_9961f986823b4be7f5c4cc8379c6b228) : void
    {
        Util::assertTextGenerationParts($_9961f986823b4be7f5c4cc8379c6b228);
        $this->dispatchEvent(AiEventType::TEXT_PROMPT, $_9961f986823b4be7f5c4cc8379c6b228);
        $this->adapter->generateTextStream($_5c51b0e4b7267b43adabf8015a8e1cf8, $_9961f986823b4be7f5c4cc8379c6b228);
    }
    public function generateImages(string $_a51236f5e7f12cf84a776152098d24a9, ?AiImageConfiguration $_96a90e63b3679cfbc97e4f9bc15d4d2a = null) : array
    {
        $this->dispatchEvent(AiEventType::IMAGE_PROMPT, $_a51236f5e7f12cf84a776152098d24a9);
        return $this->adapter->generateImages($_a51236f5e7f12cf84a776152098d24a9, $_96a90e63b3679cfbc97e4f9bc15d4d2a);
    }
    public function generateTextEmbedding($_9961f986823b4be7f5c4cc8379c6b228) : array
    {
        Util::assertTextGenerationParts($_9961f986823b4be7f5c4cc8379c6b228);
        return $this->adapter->generateTextEmbedding($_9961f986823b4be7f5c4cc8379c6b228);
    }
    
    
    
    
    
    
    
    public function isModuleEnabled(string $module) : bool
    {
        return $this->config->has($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_2e384775c6854f15e613f8d" . "a88db608d"]) && ($this->config->get($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_2e384775c6854f15e61" . "3f8da88db608d"])[$module] ?? false);
    }
    
    
    
    
    
    
    public function getModules()
    {
        $_59eea0afb98cc6c83c49d730362a45fd = [];
        foreach ($this->plugins as $_38198dbb7190fed0f875632ecef1ac6f) {
            $_59eea0afb98cc6c83c49d730362a45fd[] = $_38198dbb7190fed0f875632ecef1ac6f->getModule();
        }
        $_59eea0afb98cc6c83c49d730362a45fd = $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_075c6c41" . "72eaf58cf" . "a84828a35" . "82d19a"]($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_ea8229a121285ee6" . "49a72fd880bac39b"]($_59eea0afb98cc6c83c49d730362a45fd));
        $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_a70b8baf1a135547a2710020" . "0b31ba5e"]($_59eea0afb98cc6c83c49d730362a45fd);
        return $_59eea0afb98cc6c83c49d730362a45fd;
    }
    
    
    
    
    
    
    
    public function getModulePlugins(string $module) : array
    {
        $_a99e51514fd0fcca58579cb5552a6035 = [];
        foreach ($this->plugins as $_38198dbb7190fed0f875632ecef1ac6f) {
            if ($_38198dbb7190fed0f875632ecef1ac6f->getModule() === $module) {
                $_a99e51514fd0fcca58579cb5552a6035[] = $_38198dbb7190fed0f875632ecef1ac6f;
            }
        }
        return $_a99e51514fd0fcca58579cb5552a6035;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function getSystemPromptParts(AiPluginInterface $_38198dbb7190fed0f875632ecef1ac6f, ?string $_a05cd0d81b0d993868f75f877961db96 = null, ?array $_b255ebafd5b8bb45110cd2db0604fa44 = null) : array
    {
        
        
        $_a05cd0d81b0d993868f75f877961db96 = $this->getSupportedLanguage($_a05cd0d81b0d993868f75f877961db96);
        return $_38198dbb7190fed0f875632ecef1ac6f->getSystemPromptParts($_a05cd0d81b0d993868f75f877961db96, $_b255ebafd5b8bb45110cd2db0604fa44);
    }
    
    
    
    
    
    
    
    
    public function getPlugin(string $module, string $_2236a44cb0a254e187e94523cbb4ccbb) : ?AiPluginInterface
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_bd71c3b5c201fc11db82ed14ce424" . "de5"]($_2236a44cb0a254e187e94523cbb4ccbb, AiPluginInterface::TYPES)) {
            throw new \InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_34725a20914b07a2" . "8de7045ef89ffe6e"]);
        }
        $_38198dbb7190fed0f875632ecef1ac6f = null;
        foreach ($this->plugins as $_38198dbb7190fed0f875632ecef1ac6f) {
            if ($_38198dbb7190fed0f875632ecef1ac6f->getModule() === $module && $_38198dbb7190fed0f875632ecef1ac6f->getType() === $_2236a44cb0a254e187e94523cbb4ccbb) {
                return $_38198dbb7190fed0f875632ecef1ac6f;
            }
        }
        return $_38198dbb7190fed0f875632ecef1ac6f;
    }
    
    
    
    
    
    
    
    
    
    
    
    protected function getSupportedLanguage(?string $language) : string
    {
        $language = \Languages::DetectLanguage($language);
        $_3a9ee8592d2799f4e3ba31426430d858 = $this->isLanguageSupported($language);
        return $_3a9ee8592d2799f4e3ba31426430d858 ? $language : $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_4298577e4189" . "4bcce23f896cd" . "365aea4"];
    }
    
    
    
    
    
    
    
    public function isLanguageSupported(string $language) : bool
    {
        return $this->adapter->isLanguageSupported($language);
    }
    
    
    
    
    
    
    
    
    public function getInformation() : AiInformation
    {
        return $this->adapter->getInformation();
    }
    
    
    
    
    
    
    
    
    protected function dispatchEvent(string $_18c3ae9a896c5ec6d2e49d0d9d3852f2, $_9961f986823b4be7f5c4cc8379c6b228) : void
    {
        $event = new AiEvent($_9961f986823b4be7f5c4cc8379c6b228);
        $this->dispatcher->dispatch($event, $_18c3ae9a896c5ec6d2e49d0d9d3852f2);
    }
}